



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ASN.1笔记——语法规则与类型概述</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ASN.1笔记——语法规则与类型概述</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 12:55:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转载：<a href="https://blog.csdn.net/sever2012/article/details/7672699" rel="external nofollow noreferrer">https://blog.csdn.net/sever2012/article/details/7672699</a></p>
<h2>一.简介</h2>
<p>ASN.1(Abstract Syntax Notation dotone),抽象语法标记1。是定义抽象数据类型形式的标准,是用于描述数据表示、表示、传输、编码的记法。</p>
<p>ASN.1只包含信息结构，不处理具体业务数据，它不是一个编程语言。</p>
<p>ASN.1没有限定编码方法，各种ASN.1编码规则提供了由ASN.1描述其抽象句法的数据的值的传送语法（具体表达），常见的编码规则有：基本编码规则(BER),规范编码规则（CER，CanonicalEncoding Rules）、唯一编码规则（DER，DistinguishedEncoding Rules）、压缩编码规则（PER，PackedEncoding Rules）和XML编码规则（XER，XMLEncoding Rules）。这些编码规则描述了如何将定义在ASN.1中的值译成适合传输的电码。</p>
<p>ASN.1在OSI的ISO8824/ITU X.208（说明语法）和ISO8825/ITU X.209（说明基本编码规则）规范。</p>
<p>几个概念：</p>
<p>(1)实际语法</p>
<p>指诸如C、ObjectiveCaml等这样实际编程语言；</p>
<p>(2)抽象语法（AbstractSyntax）</p>
<p>指ASN.1，是协议采用ASN.1规范描述的描述文本。描绘了与任何表示数据的编码技术无关的通用数据结构。抽象语法使得人们能够定义数据类型，并指明这些类型的值。抽象语法只描述数据的结构形式，与具体的编码格式无关，同时也不涉及这些数据结构在计算机内如何存放。</p>
<p>(3)传输语法（TransferSyntax）</p>
<p>指表示层交换数据的表示方法，是实际通讯系统间的码流。当数据在两个表示层实体之间传输时，这些数据的实际比特模式表示方法就是传送语法。</p>
<p>(4)编码</p>
<p>指将抽象语言法转换成实际通讯系统间比特流;</p>
<p>(5)编码规则</p>
<p>将抽象语言法转换成实际通讯系统间比特流所遵循的语法规则;</p>
<h2>二.相关背景知识</h2>
<p>1.为了顺利完成应用音的通讯，需使用以下概念：</p>
<p>(1)抽象语法：定义了数据的常用结构（包括不同的数据类型），并且建立了和应用层对话所用的构架。</p>
<p>(2)实际语法：本地的，并且定义本地系统的数据表示方法。</p>
<p>(3)传输语法：定义两个系统间的表示层间交换数据的表示方法。</p>
<p>(4)编码规则：提供从本地实际语法到传输语法和其相反操作的方法。(从抽象语法到传输语法，由ASN.1编译器按照编解码规则实现)</p>
<p>2.应用层Application Layer</p>
<p>应用层向表示层发送数据时，同时告知表示层自己的ASN.1名字(即对象标识符)，ASN.1名字标记了一个ASN.1语法&mdash;&mdash;用以解释数据中各字段的含义。通过参考ASN.1定义，表示可以得知数据单元的类型和长度，以及传输时应当采用的编码方法。</p>
<p>3.表示层Presentation Layer</p>
<p>两个系统在传输数据前需要协商共用的编码方式，事实上编码方式在应用层发出的数据中已经确定，应用数据中包含抽象语法/传输语法的组合关系，告诉表示层数据的结构、含义以及传输语法规则。表示层参考抽象语法，将应用数据转换为传输语法定义的比特流。</p>
<p>4.边界对齐</p>
<p>同样一条消息，在计算机内存中是以Byte为单位存储的，在链路上则是以bit为单位传送的。</p>
<p>如果一个信元的第一个bit也恰好是Byte流中某Byte的开始bit时，我们称之为开始于边界对齐的；</p>
<p>如果信元的最后一个bit也恰好是Byte流中某Byte的最后一个bit时，则可以称之为结束于边界对齐的。</p>
<p>对于不是结束于边界对齐的情况，一般要进行补位。有两种方式：</p>
<p>(1)对每个信元的结束立即进行补位，保证下一个信元是开始于边界对齐的；</p>
<p>(2)从信元结束的位置开始新的信元，到消息结束时再进行一次补位操作。(用于无线空口中)</p>
<p>5.大小端(BigEndian vs Little Endian)</p>
<p>(1).大端方式，也叫网络序，从左往右，第一个8位表示高位，例如0X0102,用比特流表示是0000000100000010。</p>
<p>(2).小端方式，也叫主机序，与大端方式相反，数字0X0102用比特流表示则是0000001000000001，低8位在前，高8位在后。</p>
<p>Motorola的PPC系列、IP协议中使用大端方式;VAX计算机、Intel的x86系列中使用小端方式。</p>
<h2>三.ASN.1的基本语法规则</h2>
<p>1.ASN.1使用巴科斯范式(BNF):</p>
<p>在双引号中的字("word")代表着这些字符本身。而double_quote用来代表双引号。</p>
<p>在双引号外的字（有可能有下划线）代表着语法部分。</p>
<p>尖括号(&lt; &gt; )内包含的为必选项。</p>
<p>方括号([ ] )内包含的为可选项。</p>
<p>大括号({ } )内包含的为可重复0至无数次的项。</p>
<p>竖线(| )表示在其左右两边任选一项，相当于"OR"的意思。</p>
<p>::=是&ldquo;被定义为&rdquo;的意思。</p>
<p>这是用BNF来定义的Java语言中的For语句的实例：</p>
<p>　　FOR_STATEMENT::=</p>
<p>　　"for""(" ( variable_declaration |</p>
<p>　　(expression ";" ) | ";" )</p>
<p>　　[expression ] ";"</p>
<p>　　[expression ]</p>
<p>　　")"statement</p>
<p>2.在ASN.1中，符号的定义没有先后次序：只要能够找到该符号的定义即可。</p>
<p>3.所有的标识符、参考、关键字都要以一个字母开头，后接字母(大、小写都可以)、数字或者连字符&ldquo;-&rdquo;(但不能以连字符&ldquo;-&rdquo;结尾，也不能连续出现两个连字符)，不能出现下划线&ldquo;_&rdquo;。</p>
<p>4.关键字一般都是全部大写。</p>
<p>5.在标识符中，只有类型和模块名字是以大写字母开头的，其它标识符都是以小写字母开头。</p>
<p>6.ASN.1中实数实际定义为三个整数：尾数、基数和指数。没有小数表示方式。</p>
<p>7.ASN.1不对空格、制表符、换行符和注释做翻译。但是在定义符号（或者分配符号Assignment）&ldquo;::=&rdquo;中不能有分隔符。</p>
<h2>四.ASN.1中的类型</h2>
<p>类型是一个非空的值的集合，可以被编码后传输。相比与高级语言中复杂的数据结构，ASN.1中的类型主要是为了数据的传输。</p>
<p>1.ASN.1中的类型分为基本类型(内建数据类型)和组合类型，组合类型由一个或多个基本类型构成。</p>
<p>内建数据类型</p>
<dl>
<dd>
<table>
<tbody>
<tr>
<td>
<p>类型</p>
</td>
<td>
<p>含义</p>
</td>
</tr>
<tr>
<td>
<p>NULL</p>
</td>
<td>
<p>只包含一个值NULL，用于传送一个报告或者作为CHOICE类型中某些值</p>
</td>
</tr>
<tr>
<td>
<p>INTEGER</p>
</td>
<td>
<p>全部整数（包括正数和负数）</p>
</td>
</tr>
<tr>
<td>
<p>REAL</p>
</td>
<td>
<p>实数，表示浮点数</p>
</td>
</tr>
<tr>
<td>
<p>ENUMERATED</p>
</td>
<td>
<p>标识符的枚举（实例状态机的状态）</p>
</td>
</tr>
<tr>
<td>
<p>BITSTRING</p>
</td>
<td>
<p>比特串</p>
</td>
</tr>
<tr>
<td>
<p>OCTETSTRING</p>
</td>
<td>
<p>字节串</p>
</td>
</tr>
<tr>
<td>
<p>OBJECT IDENTIFIER,</p>
<p>RELATIVE-OID</p>
</td>
<td>
<p>一个实体的标识符，它在一个全世界范围树状结构中注册</p>
</td>
</tr>
<tr>
<td>
<p>EXTERNAL,EMBEDDED PDV</p>
</td>
<td>
<p>表示层上下文交换类型</p>
</td>
</tr>
<tr>
<td>
<p>&hellip;String(除了BITSTRING、OCTETSTRING外)</p>
</td>
<td>
<p>各种字符串，有NumericString、PrintableString、VisibleStirng、ISO64String、IA5String、TeletexStirng、T61String、VideotexString、GraphicString、GeneralString、UniversalString、BMPString和UTF8String</p>
</td>
</tr>
<tr>
<td>
<p>CHARACTERSTRING</p>
</td>
<td>
<p>允许为字符串协商一个明确的字符表</p>
</td>
</tr>
<tr>
<td>
<p>UTCTime,GeneralizedTime</p>
</td>
<td>
<p>日期</p>
</td>
</tr>
</tbody>
</table>
</dd>
</dl>
<p>组合类型</p>
<dl>
<dd>
<table>
<tbody>
<tr>
<td>
<p>类型</p>
</td>
<td>
<p>含义</p>
</td>
</tr>
<tr>
<td>
<p>CHOICE</p>
</td>
<td>
<p>在类型中选择(相当于C中的联合)</p>
</td>
</tr>
<tr>
<td>
<p>SEQUENCE</p>
</td>
<td>
<p>由不同类型的值组成一个有序的结构(相当于C中的结构体)</p>
</td>
</tr>
<tr>
<td>
<p>SET</p>
</td>
<td>
<p>由不同类型的值组成一个无序的结构</p>
</td>
</tr>
<tr>
<td>
<p>SEQUENCEOF</p>
</td>
<td>
<p>由相同类型的值组成一个有序的结构(相当于C中的数组)</p>
</td>
</tr>
<tr>
<td>
<p>SETOF</p>
</td>
<td>
<p>由相同类型的值组成一个无序的结构</p>
</td>
</tr>
</tbody>
</table>
</dd>
</dl>
<p>2.类型定义</p>
<p>&lt;新类型的名字&gt;::= &lt;类型描述&gt;</p>
<p>例：</p>
<p>Married ::= BOOLEAN</p>
<p>Age ::= INTEGER</p>
<p>Picture ::= BIT STRING</p>
<p>Form ::= SEQUENCE</p>
<p>{</p>
<p>name PrintableString,</p>
<p>age Age,</p>
<p>married Married,</p>
<p>marriage-certificate PictureOPTIONAL</p>
<p>}</p>
<p>Married类型是一个基本类型BOOLEAN，Form类型是一组基本类型的有序序列</p>
<p>注意：在SEQUENCE和SET等(好像应该是所有组合类型的)定义中，最后一个成员结尾没有逗号&ldquo;,&rdquo;。</p>
<p>为了接收方能正确解码，发送方为每个值的类型附加一个数，称为tag，在描述中以&ldquo;[]&rdquo;标识。缺省情况下，编码器会使用universal的tag。在给合类型中，为了明确各个成员，有必要指明每个成员的Tag：</p>
<p>Coordinates ::= SET</p>
<p>{</p>
<p>x [1] INTEGER,&nbsp;//这证明好像也可以用类来直接声明变量</p>
<p>y [2]INTEGER,</p>
<p>z [3]INTEGER OPTIONAL</p>
<p>}</p>
<p>Tag会在传输规则使用到，用于在比特流中指明数据的具体类型。</p>
<p>为了准确描述一个类型，我们需要对值的集合进行一定的限制。这用到子类型约束，在类型之后用圆括号进行标识。</p>
<p>如：</p>
<p>Lottery-number::= INTERGER(1..49)表示取1-49任一一个值</p>
<p>Lottery-draw ::=SEQUENCESIZE(6)&nbsp;OF Lottery-number指定了该SEQUENCE类型由6个Lottery-number类型有序组成。</p>
<p>Upper-case-words::= IA5String&nbsp;(FROM(&ldquo;A&rdquo;..&rdquo;Z&rdquo;))表示按ASCII取A-Z中任一一个，IA5String是ASCII字符串类型</p>
<p>为了方便在新的版本中往现有类型中添加新成员，可用&ldquo;&hellip;&rdquo;来标记可能以后是其它类型的地方：</p>
<p>Type ::= SEQUENCE</p>
<p>{</p>
<p>component1 INTERGER,</p>
<p>component2 BOOLEAN,</p>
<p>&hellip;</p>
<p>}</p>
<p>以后新的版本中，描述可能为：</p>
<p>Type ::= SEQUENCE</p>
<p>{</p>
<p>component1 INTERGER,</p>
<p>component2 BOOLEAN,</p>
<p>&hellip;,</p>
<p>[[component3REAL]], -- version 2</p>
<p>&hellip;</p>
<p>}</p>
<p>注意：新加入的类型成员要嵌套在&ldquo;[[]]&rdquo;中,--version 2指定新版本号</p>
<p>3.值定义</p>
<p>&lt;新的值的名字&gt;&lt;该值的类型&gt; ::=&lt;值描述&gt;</p>
<p>其中：</p>
<p>&lt;新的值的名字&gt;是以小写字母开头的标识符；</p>
<p>&lt;该值的类型&gt;可以是一个类型的名字，也可以是类型描述；</p>
<p>&lt;值描述&gt;是基于整数、字符串、标识符的组合。</p>
<p>如：</p>
<p>counter Lottery-number ::= 45</p>
<p>sextuple Lottery-draw ::= { 7, 12, 23, 31, 33, 41 }</p>
<p>4.信息对象类和信息对象</p>
<p>&lt;信息对象类&gt;::= CLASS &lt;类描述&gt;</p>
<p>WITHSYNTAX &lt;信息描述&gt;</p>
<p>用于表达比注释更为正式的一些信息</p>
<p>5.模块定义</p>
<p>&lt;模块名字&gt; DEFINITIONS &lt;缺省Tag&gt;::=</p>
<p>BEGIN</p>
<p>EXPORTS &lt;导出描述&gt;</p>
<p>IMPORTS &lt;导入描述&gt;</p>
<p>&lt;模块体描述&gt;</p>
<p>END</p>
<p>一般协议由一个或者多个模块组成，模块用来收集数据结构定义。</p>
<p>模块名字必须以大写字母开头。模块能以一种&ldquo;全局指针&rdquo;(UniversalPointer)的方式来引用，称为对象标识符（ObjectIdentifier），用花括号标识在名字之后。</p>
<p>如：</p>
<p>Module2 { isomember-body(2) f(250) type-org(1) ft(16)</p>
<p>asn1-book(9)chapter5(0) module2(1) }</p>
<p>DEFINITIONS AUTOMATICTAGS ::=</p>
<p>BEGIN</p>
<p>EXPORTS Type2;</p>
<p>IMPORTS Type1, valueFROM Module1 {iso member-body(2)</p>
<p>f(250) type-org(1)ft(16) asn1-book(9) chapter5(0) module1(0)};</p>
<p>Type2 ::= SEQUENCE OFChoice</p>
<p>Choice ::= CHOICE</p>
<p>{</p>
<p>a INTEGER (0..value),</p>
<p>b Type1</p>
<p>}</p>
<p>END</p>
<p>(1).AUTOMATICTAGS是指缺省Tag，说明不关注模块的Tag。</p>
<p>(2).IMPORTS声明在其它模块定义但在本模块会用到的类型或者值。</p>
<p>EXPORT声明在本模块之外可以访问的类型或者值。</p>
<p>IMPORTS的语法为：</p>
<p>IMPORTS &lt;名字&gt;,value FROM &lt;其它模块的ObjectIdentifier &gt;;</p>
<p>EXPORTS的语法为：</p>
<p>EXPORTS&lt;名字&gt;;</p>
<p>(3).对象标识符(OBJECTIDENTIFIER,OID)类型用层次的形式来表示标准规范。标识符树通过一个点分的十进制符号来定义，这个符号以组织，子部分然后是标准的类型和各自的子标识符开始．</p>
<p>例如：MD5的OID是1.2.840.113549.2.5表示为"iso(1)member-body (2) US (840) rsadsi(113549) digestAlgorithm (2) md5 (5)",所以当解码程序看到这个OID时,就知道是MD5散列。</p>
<p>OID在公钥算法标准中很流行,它指出证书绑定了哪种散列算法。</p>
<p>OID在传输时编码规则:</p>
<ul><li><p>前两部分如果定义为x.y,那么它们将合成一个字40*x+ y,其余部分单独作为一个字节进行编码。</p></li>
<li><p>每个字首先被分割为最少数量的没有头零数字的7位数字.这些数字以big-endian格式进行组织,并且一个接一个地组合成字节.除了编码的最后一个字节外,其他所有字节的最高位(位8)都为1。</p></li></ul>
<p>MD5OID的编码:</p>
<p>&lt;1&gt;.将1.2.840.113549.2.5转换成字数组{42,840, 113549, 2, 5}。</p>
<p>&lt;2&gt;.然后将每个字分割为带有最高位的7位数字，{{0x},{0x86,0x48},{0x86,0xF7,0x0D},{0x02},{0x05}}。</p>
<p>&lt;3&gt;.最后完整的编码为0x0608 86 48 7 0D 02 05。　</p>
<p>6.模块和分配(Assignment)</p>
<p>(1).定义一个新类型</p>
<p>TypeReference ::=CHOICE</p>
<p>{</p>
<p>integer INTEGER,</p>
<p>boolean BOOLEAN</p>
<p>}</p>
<p>(2).给类型赋值</p>
<p>在ASN.1中给类型赋的值不会被编码(ASN.1语法只是一种语法规则用来描述业务数据，而不会被当成业务数据)，这种值常用作DEFAULT，上下界或者信息对象中。</p>
<p>value-referenceTypeReference ::= integer:12</p>
<p>如果两个类型在语法上是完全一样的，则这两种类型的值可以相互赋值。如：</p>
<p>Pair::= SEQUENCE</p>
<p>{</p>
<p>x INTEGER,</p>
<p>y INTEGER</p>
<p>}</p>
<p>Couple::= SEQUENCE</p>
<p>{</p>
<p>x INTEGER,</p>
<p>y INTEGER</p>
<p>}</p>
<p>pairPair ::= {x 5, y 13}</p>
<p>coupleCouple ::= pair</p>
<p>(3).值集合</p>
<p>在语义上，一个值集合相当于一个添加约束后的类型。如：</p>
<p>PrimeNumbers INTEGER ::= {2 | 3 | 5 | 7 | 11 | 13}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxj36v9.html">BZOJ3607 &colon; 数据网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmve09.html">转：不是技术牛人，如何拿到国内IT巨头的Offer</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z5oez9.html">Android与OpenCV&mdash;&mdash;重新下载安装和OpenCV匹配的Android开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mngmeq.html">mina 字节数组编解码器的写法 II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm77y69.html">POJ1365 - Prime Land（质因数分解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn5y66q.html">python&lowbar;安装工具easy&lowbar;install和pip</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdemm6v9.html">codeforces 665E Beautiful Subarrays</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz0y7g8.html">学了Java  你未必知道这些</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyy3pe9.html">can&amp;amp&semi;&num;39&semi;t connect to mysql server on localhost &amp;amp&semi;lt&semi;10061&amp;amp&semi;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn1xk9.html">如何使用bootstrap</a>
		</li>
						<li><a href="https://www.batexi.com/a/9501w5e8.html">AIX 命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22m4pq.html">spring深入学习&lpar;二&rpar;-----bean的生命周期、IOC容器bean装配</a>
		</li>
						<li><a href="https://www.batexi.com/a/9600v3j9.html">Docker在Linux上运行NetCore系列（四）使用私有Nuget与多个本地包引用运行ASPNetCore</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w024wq.html">CADO SAP tcode - Time Sheet&colon; Display Data</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emeewk9.html">mysql数据库管理工具&lpar;navicat for mysql&rpar; 10&period;1&period;7 绿色中文版</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmv5lg9.html">CF613D&colon;Kingdom and its Cities&lpar;树形DP&comma;虚树&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp0on79.html">【Android】11&period;5 创建和管理Fragments</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjnmjvq.html">如何监控GPU使用情况并杀死指定其中进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k7olvq.html">【转】Keepalived无法绑定VIP故障排查经历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlompnxq.html">drone 学习五 集成gitlab 配置以及简单测试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdjnwl7q.html">Python2和Python3共存安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve6z0y9.html">在Centos系统下使用命令安装gnome图形界面程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e6nje9.html">Mahout源码目录说明&amp;amp&semi;&amp;amp&semi;算法集</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn7yykq.html">《JavaScript 实战》：实现图片幻滑动展示效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp03ey9.html">如何写出高性能SQL语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pr7jnq.html">hihoCoder &num;1175 &colon; 拓扑排序&amp;&num;183&semi;二</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emn3pk9.html">vc 播放音乐</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e60lk9.html">vps建站教程 CentOS6如何安装配置FTP服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9534n2v8.html">git&commat;oschina&period;net源代码管理使用日记【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9534yz08.html">java线上应用故障排查之二：高内存占用【转】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
